VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmProve 
   BorderStyle     =   1  'Fixed Single
   Caption         =   " Prove per livelli"
   ClientHeight    =   6540
   ClientLeft      =   150
   ClientTop       =   435
   ClientWidth     =   9510
   Icon            =   "frmProve.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MDIChild        =   -1  'True
   ScaleHeight     =   6540
   ScaleWidth      =   9510
   Begin VB.CheckBox chkValoriLivelli 
      Caption         =   "&Valori dei Livelli:"
      Height          =   255
      Left            =   7680
      TabIndex        =   6
      Top             =   6120
      Width           =   1455
   End
   Begin VB.CheckBox chkPerimetro 
      Caption         =   "&Perimetro"
      Height          =   255
      Left            =   6600
      TabIndex        =   5
      Top             =   6120
      Width           =   1035
   End
   Begin VB.CheckBox chkTriangoli 
      Caption         =   "&Triangoli"
      Height          =   255
      Left            =   5520
      TabIndex        =   4
      Top             =   6120
      Width           =   915
   End
   Begin MSComDlg.CommonDialog CMDialog1 
      Left            =   8640
      Top             =   300
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.TextBox txtNLiv 
      Height          =   285
      Left            =   2640
      TabIndex        =   1
      ToolTipText     =   "Invio, per confermare "
      Top             =   6120
      Width           =   735
   End
   Begin VB.OptionButton optAree 
      Caption         =   "&Aree"
      Height          =   255
      Left            =   3720
      TabIndex        =   2
      Top             =   6120
      Value           =   -1  'True
      Width           =   795
   End
   Begin VB.OptionButton optLinee 
      Caption         =   "&Linee"
      Height          =   255
      Left            =   4560
      TabIndex        =   3
      Top             =   6120
      Width           =   795
   End
   Begin VB.PictureBox picLivelli 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      Height          =   5835
      Left            =   120
      MousePointer    =   2  'Cross
      ScaleHeight     =   5775
      ScaleWidth      =   9195
      TabIndex        =   7
      Top             =   120
      Width           =   9255
   End
   Begin VB.Label zLabel02 
      BackStyle       =   0  'Transparent
      Caption         =   "&N Livelli:"
      Height          =   195
      Left            =   1920
      TabIndex        =   0
      Top             =   6120
      Width           =   675
   End
   Begin VB.Label zLabel01 
      BackStyle       =   0  'Transparent
      Caption         =   "N punti:"
      Height          =   195
      Left            =   180
      TabIndex        =   9
      Top             =   6120
      Width           =   735
   End
   Begin VB.Label lblND 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   840
      TabIndex        =   8
      Top             =   6120
      Width           =   735
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuLeggiDati 
         Caption         =   "&Leggi file dati"
      End
      Begin VB.Menu zSep01 
         Caption         =   "-"
      End
      Begin VB.Menu mnuEsci 
         Caption         =   "&Esci"
      End
      Begin VB.Menu zSep02 
         Caption         =   "-"
      End
      Begin VB.Menu mnuRecenti 
         Caption         =   "Files Recenti:"
         Index           =   0
      End
   End
   Begin VB.Menu mnuQM 
      Caption         =   "&?"
      Begin VB.Menu mnuInformazioni 
         Caption         =   "&Informazioni su LivellPS"
      End
   End
End
Attribute VB_Name = "frmProve"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'=========================================================================
' Descrizione.....: Form di prova per le routines DELLIV ( F. Languasco).
' Nome dei Files..: frmLivelliPS.frm, frmLivelliPS.frx
'                   frm3D.frm, frm3D.frx
'                   modUtilita.bas
' Data............: 17/07/2004
' Versione........: 1.0 a 32 bits.
' Sistema.........: VB6 (SP5) sotto Windows NT (SP6).
' Scritto da......: F. Languasco 
' E-Mail..........: MC7061@mclink.it
' DownLoads a.....: http://www.flanguasco.org
'                   http://members.xoom.virgilio.it/flanguasco
'=========================================================================
'
'   Nota:   Tutti i vettori e le matrici di queste routines
'           iniziano dall' indice 1 (ZCol() escluso).
'
Option Explicit
'
Dim ND&             ' N di dati nei vettori.
Dim XD#()           ' Vettori delle coordinate
Dim YD#()           ' dei punti dati.
Dim ZD#()           '
'
Dim XMin#, XMax#    ' Valori Min. e Max. delle coordinate
Dim YMin#, YMax#    ' dei punti dati.
Dim ZMin#, ZMax#    '
'
Dim ZCol&()         ' Tavola dei colori.
Const NTCol& = 256  ' Numero di colori disponibili in ZCol().
Dim NLiv&           ' Numero di livelli da tracciare.
'
Dim FolderN$        ' Folder dei files dati.
Dim Titolo$         ' Nome del file correntemente usato.
'
Dim bTriangoli As Boolean   ' Disegna la triangolazione.
Dim bPerimetro As Boolean   ' Disegna il "convex hull" dei punti dati sul piano X-Y.
Dim bScriviVal As Boolean   ' Scrive i valori delle linee di livello.
Private Sub chkPerimetro_Click()
'
'
    bPerimetro = (chkPerimetro.Value = vbChecked)
    DisegnaLivelli
'
'
'
End Sub
Private Sub chkTriangoli_Click()
'
'
    bTriangoli = (chkTriangoli.Value = vbChecked)
    DisegnaLivelli
'
'
'
End Sub

Private Sub chkValoriLivelli_Click()
'
'
    bScriviVal = (chkValoriLivelli.Value = vbChecked)
    DisegnaLivelli
'
'
'
End Sub
Private Sub Form_Load()
'
'
    Dim Me_L&, Me_T&, FileN$
'
    LeggiPosizioneForm Me, Me_L, Me_T
    Me.Move Me_L, Me_T ', Me_W, Me_H
    CloseButtonDisable Me
    Me.Show
'
    LeggiFilesRecenti Me.mnuRecenti, "PuntiDati"
'
    ' Carico la tabella dei colori da usare:
    ZCol() = TabellaColori(NTCol)
'
    NLiv = 10   ' Numero di livelli da tracciare.
    txtNLiv = NLiv
'
    chkValoriLivelli.Visible = optLinee.Value
'
    ' Leggo un file iniziale:
    'FileN$ = App.Path & "\Orografia.dat"
    FileN$ = App.Path & "\Masoud_Points.txt"
    'FileN$ = App.Path & "\Prova3D.Txt"
    'FileN$ = App.Path & "\Prova3D_1.Txt"
    'FileN$ = App.Path & "\William.Txt"
'
    If LeggiFile(FileN$) Then
        DisegnaLivelli
        DisegnaTriangolazioneIn3D
    End If
'
'
'
End Sub
Private Sub DisegnaLivelli()
'
'   Draw the level curves:
'
    Dim L&, DLiv#, Msg$
    ReDim ZLin(1 To NLiv) As LineaLivello_Type
    Const Eps# = 0.000000001
'
    ' Frame setup:
    Quadro picLivelli, XMin, XMax, YMin, YMax, , , , , , "LivelliPS di: " & Titolo$, _
           "x", "y", True
'
    ' Level structure preparation for DELLIV:
    DLiv = (ZMax - ZMin) / (NLiv - 1)
    For L = 1 To NLiv
        ZLin(L).dLinVal = ZMin + (L - 1) * DLiv
        ZLin(L).lLinCol = ZCol((L - 1) * (NTCol - 1) / (NLiv - 1))
        ZLin(L).lLinSps = 1
        ZLin(L).lLblCol = ZLin(L).lLinCol
        If bScriviVal Then
            ZLin(L).sLblTes = Format$(ZLin(L).dLinVal, "#0.000")
        Else
            ZLin(L).sLblTes = ""
        End If
        ZLin(L).lLblFSz = 10
    Next L
'
    ' Find the level curves:
    If optLinee.Value Then
        ZLin(1).dLinVal = ZLin(1).dLinVal + DLiv * Eps
        ZLin(NLiv).dLinVal = ZLin(NLiv).dLinVal - DLiv * Eps
        DELLIV_Lines picLivelli, XD(), YD(), ZD(), ZLin(), Msg$, bTriangoli, bPerimetro
'
    ElseIf optAree.Value Then
        DELLIV_Solid picLivelli, XD(), YD(), ZD(), ZLin(), Msg$, bTriangoli, bPerimetro
    End If
    If Msg$ <> "" Then MsgBox Msg$, vbCritical, "DisegnaLivelli"
'
'
'
End Sub
Private Sub Form_Unload(Cancel As Integer)
'
'
    If IsLoaded(frm3D) Then Unload frm3D
'
    SalvaFilesRecenti Me.mnuRecenti, "PuntiDati"
'
    SalvaPosizioneForm Me
'
'
'
End Sub

Private Sub mnuEsci_Click()
'
'
    Unload frmLivelliPS
'
'
'
End Sub

Private Sub mnuInformazioni_Click()
'
'
    frmCopyright.Apri Me
'
'
End Sub
Private Sub mnuLeggiDati_Click()
'
'
    Dim FN_Temp$, M$
'
    On Error GoTo mnuLeggi_Click_ERR
'
    FN_Temp$ = CMDialog_Files(CMDialog1, "Open", "Files dati", "*.dat;*.txt", _
                              FolderN$, , " Dati della superficie da interpolare")
'
'
    If BreakDown(FN_Temp$, FolderN$) Then
        LeggiFile FN_Temp$
        DisegnaLivelli
        DisegnaTriangolazioneIn3D
    End If
'
'
mnuLeggi_Click_ERR:
    If Err <> 0 And Err <> cdlCancel Then
        M$ = "Errore " & Str$(Err.Number) & vbNewLine
        M$ = M$ & Err.Description
        MsgBox M$, vbCritical, " mnuLeggiDati/" & Err.Source
    End If
'
'
'
End Sub

Private Sub mnuRecenti_Click(INDEX As Integer)
'
'
    Dim FN_Temp$
'
    If INDEX = 0 Then Exit Sub
'
'
    FN_Temp$ = mnuRecenti(INDEX).Caption
    FN_Temp$ = Right$(FN_Temp$, Len(FN_Temp$) - 3)
'
    If BreakDown(FN_Temp$, FolderN$) Then
        LeggiFile FN_Temp$
        DisegnaLivelli
        DisegnaTriangolazioneIn3D
    End If
'
'
'
End Sub
Private Sub optAree_Click()
'
'
    chkValoriLivelli.Visible = optLinee.Value
'
    DisegnaLivelli
'
'
'
End Sub
Private Sub optLinee_Click()
'
'
    chkValoriLivelli.Visible = optLinee.Value
'
    DisegnaLivelli
'
'
'
End Sub
Private Sub ReadPolarData()
'
'   Routine for converting data given as polar coordinate
'   table to vectors with cartesian coordinates:
'
    Dim I&, J&, N&, Rho#, THETA#
    Dim NCol&, NRow&, PolarTable#()
    Dim FileN$, FF%, a$, Numeri As Variant
'
    FileN$ = App.Path & "\PolarData_02.txt"
'
    FF = FreeFile
    Open FileN$ For Input As #FF
'
    Line Input #FF, a$
    Numeri = Split(a$, vbTab)
    NCol = UBound(Numeri)
    NRow = 0
    ReDim PolarTable(0 To NCol, 0 To NRow)
'
    ' I get the first row with the distances from the center:
    For I = 0 To NCol
        PolarTable(I, NRow) = Val(Numeri(I))
    Next I
'
    ' I get the other rows. The first column
    ' holds the directions:
    Do While Not EOF(FF)
        Line Input #FF, a$
'
        Numeri = Split(a$, vbTab)
        NCol = UBound(Numeri)
        NRow = NRow + 1
        ReDim Preserve PolarTable(0 To NCol, 0 To NRow)
'
        For I = 0 To NCol
            PolarTable(I, NRow) = Val(Numeri(I))
        Next I
    Loop
'
    Close #FF
'
    ND = NRow * NCol
    ReDim XD#(1 To ND), YD#(1 To ND), ZD#(1 To ND)
'
    ' Convert polar coordinates to
    ' cartesian and find Min, Max values:
    N = 0
    XMin = 1E+38
    XMax = -1E+38
    YMin = 1E+38
    YMax = -1E+38
    ZMin = 1E+38
    ZMax = -1E+38
    For I = 1 To NCol
        Rho = PolarTable(I, 0)
        For J = 1 To NRow
            N = N + 1
            THETA = PolarTable(0, J)
            XD(N) = Rho * Cos(THETA * 180 / PI)
            YD(N) = Rho * Sin(THETA * 180 / PI)
            ZD(N) = PolarTable(I, J)
'
            If XMin > XD(N) Then XMin = XD(N)
            If XMax < XD(N) Then XMax = XD(N)
            If YMin > YD(N) Then YMin = YD(N)
            If YMax < YD(N) Then YMax = YD(N)
            If ZMin > ZD(N) Then ZMin = ZD(N)
            If ZMax < ZD(N) Then ZMax = ZD(N)
        Next J
    Next I
'
    ' Save the cartesian coordinate vectors:
    FileN$ = App.Path & "\Masoud_Points.txt"
    FF = FreeFile
'
    Open FileN$ For Output As #FF
'
    For N = 1 To ND
        Print #FF, XD(N), YD(N), ZD(N)
    Next N
'
    Close #FF
'
'
'
End Sub
Private Sub DisegnaTriangolazioneIn3D()
'
'
    Dim I&, NT&, IERR&
    ReDim Vcl#(1 To 2, 1 To ND), Ind&(1 To ND)
    ReDim TIL&(1 To 3, 1 To ND * 2), TNBR&(1 To 3, 1 To ND * 2)
'
    For I = 1 To ND
        ' Organizzo le coordinate dei vertici come
        ' richiesto dalle routines di modDelaunay2D:
        Vcl(1, I) = XD(I)
        Vcl(2, I) = YD(I)
        Ind(I) = I  ' Triangolazione di tutti i vertici contenuti in VCL().
    Next I
'
    'DTRIS2 ND, VCL(), Ind(), NT, TIL(), TNBR(), IERR
    DTRIW2 ND, Vcl(), Ind(), NT, TIL(), TNBR(), IERR
'
    If IERR = 0 Then
        ReDim Preserve TIL(1 To 3, 1 To NT)
        frm3D.Triangoli XD(), YD(), ZD(), TIL(), "Delaunay 2D di: " & Titolo$
'
    Else
        MsgBox "Errore di triangolazione IERR = " & IERR & vbNewLine _
             & "(Vedere tabella degli errori)", vbCritical, " Prova"
    End If
'
'
'
End Sub

Private Sub picLivelli_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
'
'
    picLivelli.ToolTipText = ""
    picLivelli.ToolTipText = X & ", " & Y
'
'
'
End Sub
Private Sub txtNLiv_KeyPress(KeyAscii As Integer)
'
'
    Select Case KeyAscii
    Case vbKeyEscape
        txtNLiv = NLiv
'
    Case vbKeyReturn
        If Val(txtNLiv) > 1 Then
            NLiv = Val(txtNLiv)
            DisegnaLivelli
        Else
            txtNLiv = NLiv
        End If
    End Select
'
    KeyAscii = KAscNumInteri(KeyAscii)
'
'
'
End Sub
Private Function LeggiFile(ByVal FileN$) As Boolean
'
'
    Dim FF%
'
    On Error GoTo LeggiFile_ERR
'
    FF = FreeFile
    Open FileN$ For Input As #FF
    BreakDown FileN$, , Titolo$
'
    ' Legge i punti dati dal file:
    ND = 0
    XMin = 1E+38
    XMax = -1E+38
    YMin = 1E+38
    YMax = -1E+38
    ZMin = 1E+38
    ZMax = -1E+38
    Do While Not EOF(FF)
        ND = ND + 1
        ReDim Preserve XD(1 To ND), YD(1 To ND), ZD(1 To ND)
        Input #FF, XD(ND), YD(ND), ZD(ND)
'
        If XMin > XD(ND) Then XMin = XD(ND)
        If XMax < XD(ND) Then XMax = XD(ND)
        If YMin > YD(ND) Then YMin = YD(ND)
        If YMax < YD(ND) Then YMax = YD(ND)
        If ZMin > ZD(ND) Then ZMin = ZD(ND)
        If ZMax < ZD(ND) Then ZMax = ZD(ND)
    Loop
    lblND = ND
'
    AggiornaFilesRecenti mnuRecenti, FileN$
'
LeggiFile_ERR:
    Close FF
    LeggiFile = (Err = 0)
    If (Err <> 0) Then
        MsgBox "File dati errato o corrotto.", vbCritical, "LeggiFile"
    End If
'
'
'
End Function
